VERSION 5.00
Begin VB.Form App_Note_IVI 
   Caption         =   "2701 Using the IVI driver"
   ClientHeight    =   4545
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7980
   Icon            =   "App Note-IVI.frx":0000
   LinkTopic       =   "Form2"
   ScaleHeight     =   4545
   ScaleWidth      =   7980
   StartUpPosition =   2  'CenterScreen
   Begin VB.Frame frmunit2 
      Caption         =   "Unit #2"
      Height          =   1335
      Left            =   3000
      TabIndex        =   10
      Top             =   2400
      Width           =   1815
      Begin VB.TextBox txtIPunit 
         Height          =   375
         Index           =   1
         Left            =   240
         TabIndex        =   11
         Top             =   720
         Width           =   1335
      End
      Begin VB.Label lblIPunit1 
         Alignment       =   2  'Center
         Caption         =   "IP Address Unit"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Index           =   1
         Left            =   240
         TabIndex        =   12
         Top             =   360
         Width           =   1455
      End
   End
   Begin VB.Frame frmprogoptions 
      Caption         =   "Program Options"
      Height          =   3495
      Left            =   240
      TabIndex        =   3
      Top             =   720
      Width           =   1935
      Begin VB.CheckBox chkLog 
         Caption         =   "Log to file"
         Height          =   375
         Left            =   360
         TabIndex        =   13
         Top             =   1320
         Width           =   1455
      End
      Begin VB.CommandButton cmdconnect1 
         Caption         =   "Configure"
         Height          =   255
         Left            =   240
         TabIndex        =   9
         Top             =   2040
         Width           =   1335
      End
      Begin VB.CommandButton cmddata1 
         Caption         =   "Start Scan"
         Height          =   255
         Left            =   240
         TabIndex        =   8
         Top             =   2400
         Width           =   1335
      End
      Begin VB.CommandButton cmdstop 
         Caption         =   "Stop Scan"
         Height          =   255
         Left            =   240
         TabIndex        =   7
         Top             =   2760
         Width           =   1335
      End
      Begin VB.CommandButton cmdclose 
         Caption         =   "Exit"
         Height          =   255
         Left            =   240
         TabIndex        =   6
         Top             =   3120
         Width           =   1335
      End
      Begin VB.OptionButton optunitnum 
         Caption         =   "Dual Units"
         Height          =   375
         Index           =   1
         Left            =   360
         TabIndex        =   5
         Top             =   840
         Width           =   1455
      End
      Begin VB.OptionButton optunitnum 
         Caption         =   "Single Unit"
         Height          =   375
         Index           =   0
         Left            =   360
         TabIndex        =   4
         Top             =   360
         Value           =   -1  'True
         Width           =   1455
      End
   End
   Begin VB.Frame frmunit1 
      Caption         =   "Unit #1"
      Height          =   1335
      Left            =   3000
      TabIndex        =   0
      Top             =   960
      Width           =   1815
      Begin VB.TextBox txtIPunit 
         Height          =   375
         Index           =   0
         Left            =   240
         TabIndex        =   2
         Top             =   720
         Width           =   1335
      End
      Begin VB.Label lblIPunit1 
         Alignment       =   2  'Center
         Caption         =   "IP Address Unit"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Index           =   0
         Left            =   120
         TabIndex        =   1
         Top             =   360
         Width           =   1575
      End
   End
   Begin VB.Image Image1 
      Height          =   450
      Left            =   120
      Picture         =   "App Note-IVI.frx":030A
      Top             =   120
      Width           =   7800
   End
End
Attribute VB_Name = "App_Note_IVI"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' This program uses the IVI driver to control 1 or 2 2701s to scan 5 channels of
' K thermocouple and store the readings in the internal buffer.
'
' This program is designed go along with the 2701 programming the Model 2701 Ethernet-based
' DMM application note.  This program gives you the option of saving the information to a data
' file when you exit the program.  This file is in the same directory as the program and is saved as
' comma delimited file with the extension .csv which will automatically load into Microsoft Excel
'
' Refer to the app note for further information on the program
'
' Version 1.0
'
' Eric E. Bloam
'
'
'

Option Explicit
Dim pointer As ViInt32
Dim unitdata(5, 450000) As ViReal64
Dim datasize(20) As Integer


Private Sub buffer()
Dim data(450000) As ViReal64

Dim retSize As ViInt32
Dim xx As ViInt32
Dim X As Integer
Dim Y As Integer

 For X = 0 To instnum
     
CheckError vi(X), KE2700_GetAttributeViInt32(vi(X), VI_NULL, KE2700_ATTR_BUF_POINTER_LOCATION, pointer)
' Get the buffer readings. ***** Must have the starting index in the array or program will bomb out!! ****
' Array MUST be a one dimensional Only or will get back bad/no Data
CheckError vi(X), KE2700_FetchMultiReading(vi(X), 0, pointer, 450000, data(0), retSize)
' Pointer seems to bring back the number of scans rather than the number of buffer elements
datasize(X) = (pointer * 2) - 1

DoEvents
For Y = 0 To datasize(X)
    unitdata(X, Y) = data(Y)
    DoEvents
Next Y

Next X
End Sub

Private Sub cmdclose_Click()
Dim X As Integer

If chkLog.Value = 1 Then
    buffer
    Writedata
End If

For X = 0 To instnum
KE2700_reset vi(X)
DoEvents
KE2700_close vi(X)
DoEvents

Next X
Unload Me

End Sub

Private Sub cmdconnect1_Click()
cmdconnect1.Enabled = False
Dim X As Integer
For X = 0 To instnum
Configure (X)
Next X

cmddata1.Enabled = True
cmdstop.Enabled = False
End Sub

Private Sub cmddata1_Click()
cmdclose.Enabled = False

Dim X As Integer
' Start Scan
For X = 0 To instnum
    CheckError vi(X), KE2700_Initiate(vi(X))
Next X
cmdconnect1.Enabled = False
cmddata1.Enabled = False
cmdstop.Enabled = True
End Sub

Private Sub cmdstop_Click()
Dim X As Integer
For X = 0 To instnum
CheckError vi(X), KE2700_Abort(vi(X))
Next X
cmdclose.Enabled = True

End Sub



Private Sub Writedata()
Dim X As Integer
Dim Y As Integer
Dim z As Integer

For X = 0 To instnum
z = 0
DoEvents
    Open App.Path & "\data" & X & ".csv" For Output As #(X + 1)
    For Y = 0 To datasize(X)
    DoEvents
    If z < 9 Then
        Write #(X + 1), unitdata(X, Y),
        z = z + 1
    Else
        Write #(X + 1), unitdata(X, Y), vbLf
        z = 0
        
    End If
    'DoEvents
    Next Y
   Close #(X + 1)
Next X



End Sub

Private Sub Form_Load()
'gpib = True
cmddata1.Enabled = False
cmdstop.Enabled = False
frmunit2.Visible = False

index = 0
instnum = 0

gpib = False
txtIPunit(0).Text = "192.68.1.10"
txtIPunit(1).Text = "192.68.1.20"
End Sub

Private Sub Configure(index)

' Use GPIB for 2700 and use Ethernet for the 2701... GPIB flags which one to use
If gpib = False Then
     InstrumentName(index) = "TCPIP::" & txtIPunit(index).Text & "::1394::SOCKET"
Else
    InstrumentName(index) = "GPIB1::16::INSTR"
End If

'Connect to the instrument
'Open Session
CheckError vi(index), KE2700_init(InstrumentName(index), VI_TRUE, VI_TRUE, vi(index))
' Configure for Fahrenheit
CheckError vi(index), KE2700_SetAttributeViInt32(vi(index), VI_NULL, KE2700_ATTR_TEMP_UNIT, KE2700_VAL_TEMP_FAHRENHEIT)
CheckError vi(index), KE2700_ConfigureMeasurement(KE2700_ChannelList(vi(index), "101:105"), KE2700_VAL_TEMPERATURE, KE2700_VAL_TEMP_TC_K, 0.001)


' Select Buffer Elemnets: Readings, Channel#
CheckError vi(index), KE2700_SetAttributeViInt32(vi(index), VI_NULL, KE2700_ATTR_BUF_ELEMENTS, KE2700_VAL_ELEMENT_READING + KE2700_VAL_ELEMENT_CHAN) ' Configure buffer
'Enable the auto buffer Clear
CheckError vi(index), KE2700_SetAttributeViBoolean(vi(index), VI_NULL, KE2700_ATTR_BUF_AUTO_CLR_ENABLED, VI_TRUE)
' Enable Buffer as Next
CheckError vi(index), KE2700_SetAttributeViInt32(vi(index), VI_NULL, KE2700_ATTR_BUF_DATA_CONTROL, KE2700_VAL_CONTROL_NEXT)
  
CheckError vi(index), KE2700_ConfigureTrigger(vi(index), KE2700_VAL_TIMER, 0.001)
CheckError vi(index), KE2700_SetAttributeViReal64(vi(index), VI_NULL, KE2700_ATTR_TIMER_INTERVAL, 2)
CheckError vi(index), KE2700_ConfigureMultiPoint(KE2700_ChannelList(vi(index), "101:105"), KE2700_VAL_MAX_COUNT_INFINITE, 5, KE2700_VAL_IMMEDIATE, 0#)


End Sub

Private Sub optunitnum_Click(index As Integer)
If optunitnum(1).Value = True Then
    instnum = 1
    frmunit2.Visible = True
Else
    instnum = 0
    frmunit2.Visible = False
End If
   
End Sub

