Attribute VB_Name = "KE2700_error_check"
Option Explicit


Public Sub CheckError(ByVal vi As ViSession, ByVal ErrorCode As ViStatus)
 

  If ErrorCode = VI_SUCCESS Then Exit Sub
  ErrMsg = ErrMsg & "Main Error: (Hex " & Hex(ErrorCode) & ")" & vbLf
  buffer = Space$(256)

'  If ErrorCode >= &HBFFF0000 Then
    ' Error reported by IVI Driver
    KE2700_error_message vi, ErrorCode, buffer
    buffer = RTrim$(buffer): buffer = Left(buffer, Len(buffer) - 1)     'Updated to clear away unwanted characters at the end of the returned error
    ErrMsg = ErrMsg & buffer & vbLf                                     'Updated
    KE2700_GetErrorInfo vi, PrimaryErr, SecondaryErr, ElaborationErr
    buffer = Space$(256)                                                'Updated to allow the full length of the string after the rtrim command.  Otherwise will only be the length of the previous string
    If PrimaryErr = ErrorCode And SecondaryErr <> 0 Then
      ' Check secondary error if there is any
      ErrMsg = ErrMsg & "Secondary Error: (Hex " & Hex(SecondaryErr) & ")" & vbCrLf
      KE2700_error_message vi, SecondaryErr, buffer
      buffer = RTrim$(buffer): buffer = Left(buffer, Len(buffer) - 1)   'Updated to clear away unwanted characters at the end of the returned error
      ErrMsg = ErrMsg & buffer & vbCrLf                                 'Updated
      ' Check Elaboration error if there is any
      
      If Len(ElaborationErr) > 0 Then
        ErrMsg = ErrMsg & "Elaboration: " & ElaborationErr
      End If
    End If

'  Else
'    ' Error reported by instrument.
'    KE2700_error_query vi, ErrorCode, buffer
'    ErrMsg = ErrMsg & RTrim$(buffer) & vbCrLf
'
'  End If

  'if not a warning, Raise error to the caller
  If ErrorCode < 0 Then Err.Raise ErrorCode, "IVI Driver Examples", ErrMsg
End Sub

